(* tyconstr_id is the name of an datatype constructor.
   label_id is the name of a field label or data constructor. *)
type tyconstr_id = Type of string
type label_id = Label of string

type datatype_kind = Variant_type | Record_type

type ('b,'t) datatype_descr = {
    name : tyconstr_id ;
    type_params : 'b list ;
    data_kind : datatype_kind ;
    labels_descr : 't label_descr list ;
  }

and 't label_descr = {
    label_name : label_id ;
    type_name : tyconstr_id ;
    arg_type : 't ;
  }
