(* This is the source calculus of the sample client. It is a core ML. *)

(* The terms carry no type annotations. *)

(* Nominal representation of term variables, type variables and binders. *)

type tevar = string
type tyvar = string

type term =
  | Var of tevar
  | Abs of tevar * term
  | App of term * term
  | Let of tevar * term * term
  | Tuple of term list
  | LetProd of tevar list * term * term
  | Variant of Datatype.label_id * term
  | Match of term * branch list

and branch = pattern * term

and pattern =
  | PVar of tevar
  | PWildcard
  | PVariant of Datatype.label_id * pattern
  | PTuple of pattern list

type typ =
  | TyVar of tyvar
  | TyArrow of typ * typ
  | TyProduct of typ list
  | TyConstr of Datatype.tyconstr_id * typ list

type datatype_env = (tyvar, typ) Env.t
